package counterwallrobot ;
import robocode.* ;
import java.util.* ;
import java.io.* ;

public class Cynical_3 extends AdvancedRobot
{
  //*** .
  private final boolean ANY_DEBUG =         true ;
  private final boolean TO_LOG_FILE =       true && ANY_DEBUG ;
  private final boolean TO_CONSOLE =        false && ANY_DEBUG ;
  private final boolean SWITCH_DEBUG =      true ;
  private final boolean INPUTS_LOGGING =    true && SWITCH_DEBUG && ANY_DEBUG ;
  private final boolean OUTPUTS_LOGGING =   true && SWITCH_DEBUG && ANY_DEBUG ;
  private final boolean OBJECTS_LOGGING =   true && ANY_DEBUG ;
  private final boolean A0_LOGGING =        true && SWITCH_DEBUG && ANY_DEBUG ;
  private final boolean A0_BEGIN_LOGGING =  true && A0_LOGGING && ANY_DEBUG ;
  private final boolean A0_END_LOGGING =    true && A0_LOGGING && ANY_DEBUG ;
  private final boolean A0_ERROR_LOGGING =  true && A0_LOGGING && ANY_DEBUG ;
  private final boolean A0_TRANS_LOGGING =  true && A0_LOGGING && ANY_DEBUG ;

  private final double  precision = 1e-06 ;
  private final double  PI = Math.PI ;
  private final double  dPI = 2 * PI ;
  private final double  PI2 = PI / 2 ;
  private final double  gun_rotation_speed = Math.toRadians(20) ;  //    .
  private final double  speed_max = 8 ;                            //   .
  private final double  turning_speed_max = Math.toRadians(10) ;   //   .
  private final double  max_firepower = 3 ;                        //   .
  private final double  base_firepower = max_firepower/2.0 ;       //   .
  private final double  fire_delay_critical = 400 ;                //     .
  private final double  life_ok = 50 ;
  private final double  life_warning = 30 ;
  private final double  life_critical = 15 ;

  private double        battlefield_width, battlefield_height ;    //  .
  private double        robot_size,         //  .
                        robot_size2 ;       //   .
  private double        collision_delta ;
  private int           cur_robots_count ;  //    .
  private int           total_robots_count ;//   .
  private long          cur_time ;          //   .
  private Random        random = new Random() ;
  private double        cur_life ;          //  .
  private long          last_fire_time ;    //   .
  private long          hits, misses, hitted_by_bullet ; // .
  private long          walls_collisions ;
  private radar_t       radar ;
  private driver_t      driver ;
  private gunner_t      gunner ;
  private targets_t     targets ;
  private Vector        events ;

  private int           y0 = 0 ;

  //  .
  public void
  run()
  {
    A0(9) ; //   A0   " ".

    while(true)
    {
      cur_time = getTime() ;
      log( "--------- " + cur_time + " ---------" ) ;

      check_events() ;      //   .

      A0(10) ;              //   A0   " ".
      gunner.begin_turn() ; //   " "  "".
      radar.begin_turn() ;  //   " "  "".
      driver.begin_turn() ; //   " "  "".

      end_turn() ;          //   " ".
    }
  }

  //   .
  public void
  onBulletHit( BulletHitEvent first_e )
  {
    //log( "    ." ) ;
    events.add( first_e ) ;
  }

  //   .
  public void
  onBulletMissed( BulletMissedEvent first_e )
  {
    //log( "    ." ) ;
    events.add( first_e ) ;
  }

  //    .
  public void
  onBulletHitBullet( BulletHitBulletEvent first_e )
  {
    //log( "     ." ) ;
    events.add( first_e ) ;
  }

  //  .
  public void
  onScannedRobot( ScannedRobotEvent first_e )
  {
    //log( getTime() + ":    ." ) ;
    events.add( first_e ) ;
  }

  //  .
  public void
  onRobotDeath( RobotDeathEvent first_e )
  {
    //log( "   ." ) ;
    events.add( first_e ) ;
  }

  //   .
  public void
  onHitRobot( HitRobotEvent first_e )
  {
    //log( "    ." ) ;
    events.add( first_e ) ;
  }

  //   .
  public void
  onHitWall( HitWallEvent first_e )
  {
    //log( "    ." ) ;
    events.add( first_e ) ;
  }

  //   .
  public void
  onHitByBullet( HitByBulletEvent first_e )
  {
    //log( "    ." ) ;
    events.add( first_e ) ;
  }

  // .
  public void
  onWin( WinEvent first_e )
  {
    //log( "  ." ) ;
    A0( 21 ) ;
  }

  // .
  public void
  onDeath( DeathEvent first_e )
  {
    //log( "  ." ) ;
    A0( 20 ) ;
  }

  //   A0.
  private void
  A0( int e )
  {
    int   y_old = y0 ;

    if( OBJECTS_LOGGING )
      log( "  '':" ) ;

    if( A0_BEGIN_LOGGING )
      log_begin( "A0", y0, e ) ;

    switch( y0 )
    {
      case 0:
        if( e == 9 ) { z10_0() ;                     y0 = 1 ; }
      break ;

      case 1:
        if( e == 20 || e == 21 )                     y0 = 2 ;
        else
        if( e == 10 ) { z10_2() ; }
      break ;

      case 2:
        if( e == 9 )                                 y0 = 1 ;
      break ;

      default:
        if( A0_ERROR_LOGGING )
          log_error( "A0", y0 ) ;
    }

    if( y0 != y_old )
    {

    if( A0_TRANS_LOGGING )
      log_trans( "A0", y0, y_old ) ;

    switch( y0 )
    {
      case 1:
        z10_1() ; z10_2() ;
      break ;

      case 2:
        z20() ;
      break ;

      default:
        if( A0_ERROR_LOGGING )
          log_error( "A0", y0 ) ;
    }
    }

    if( A0_END_LOGGING )
      log_end( "A0", y0 ) ;
  }

  //***   .
  private void
  z10_0()
  {
    if( OUTPUTS_LOGGING )
      log_output( "z10_0", "  " ) ;

    //   .
    setEventPriority("RobotDeathEvent", 17 );
    setEventPriority("ScannedRobotEvent", 16 );
    setEventPriority("HitRobotEvent", 15 );
    setEventPriority("HitWallEvent", 14 );
    setEventPriority("BulletHitEvent", 13 );
    setEventPriority("HitByBulletEvent", 12 );
    setEventPriority("BulletMissedEvent", 11 );

    //  .
    battlefield_width = getBattleFieldWidth() ;
    battlefield_height = getBattleFieldHeight() ;
    robot_size = (getWidth() + getHeight()) / 2.0 ;
    robot_size2 = robot_size / 2.0 ;
    collision_delta = robot_size2 - 5 ;
    hits = 0 ; misses = 0 ; hitted_by_bullet = 0 ;
    walls_collisions = 0 ;
    total_robots_count = getOthers() ;

    //  .
    targets = new targets_t() ;
    radar = new radar_t() ;
    driver = new driver_t() ;
    gunner = new gunner_t() ;
    events = new Vector() ;
  }

  private void
  z10_1()
  {
    if( OUTPUTS_LOGGING )
      log_output( "z10_1", "   " ) ;

    log( "" ) ;
    log( "====================================" ) ;
    log( "***" ) ;
    log( "***  " + (getRoundNum() + 1) ) ;
    log( "***" ) ;
    log( "====================================" ) ;
    log( "" ) ;

    clearAllEvents() ;

    setAdjustGunForRobotTurn(true);
    setAdjustRadarForGunTurn(true);

    cur_time = 0 ;

    //   " "  .
    targets.begin_round() ;
    driver.begin_round() ;
    radar.begin_round() ;
    gunner.begin_round() ;

    if( events != null ) events.clear() ;
  }

  private void
  z10_2()
  {
    if( OUTPUTS_LOGGING )
      log_output( "z10_2", "   " ) ;

    cur_robots_count = getOthers() ;
    cur_life = getLife() ;

    //   " "  " ".
    targets.begin_turn() ;
  }

  private void
  z20()
  {
    if( OUTPUTS_LOGGING )
      log_output( "z20", "  " ) ;

    show_statistics() ;
  }

  //***  .

  //     .
  private void
  check_events()
  {
    Iterator      events_iter = events.iterator() ;
    Event         e ;

    while( events_iter.hasNext() )
    {
      e = (Event)events_iter.next() ;

      if( e instanceof ScannedRobotEvent )
      {
        //  .
        targets.update( (ScannedRobotEvent)e ) ;
      }
      else
      if( e instanceof BulletHitEvent )
      {
        //   .
        targets.hit( (BulletHitEvent)e ) ;
        hits++ ;
      }
      else
      if( e instanceof RobotDeathEvent )
      {
        //  .
        targets.one_less( (RobotDeathEvent)e ) ;
      }
      else
      if( e instanceof HitRobotEvent )
      {
        //   .
        driver.robot_collision() ;
        targets.collide( (HitRobotEvent)e ) ;
      }
      else
      if( e instanceof HitWallEvent )
      {
        //   .
        driver.wall_collision() ;
        walls_collisions++ ;
      }
      else
      if( e instanceof BulletMissedEvent )
      {
        //   .
        misses++ ;
      }
      else
      if( e instanceof HitByBulletEvent )
      {
        //   .
        driver.hit_by_bullet() ;
        targets.hit_by_bullet((HitByBulletEvent)e) ;
        hitted_by_bullet++ ;
      }
    }

    events.clear() ;
  }

  //  .
  private void
  end_turn()
  {
    //log( "da = " + da*180/PI + ", da_gun = " + da_gun*180/PI + ", da_radar = " + da_radar*180/PI + ", speed = " + speed ) ;

    driver.end_turn() ; //   " "  "".
    radar.end_turn() ;  //   " "  "".
    gunner.end_turn() ; //   " "  "".
  }

  //  .
  private void
  show_statistics()
  {
    long shots = hits+misses ;

    targets.show_statistics() ;
    log( ": " + shots + ", : " + hits + ", : " + misses ) ;
    log( ": " + (double)hits/shots ) ;
    log( "  : " + hitted_by_bullet ) ;
    log( "  : " + walls_collisions ) ;
  }

  //      ,  ,
  //   .
  private vect_t
  get_path( double v, double w, double heading, double T )
  {
    vect_t  path ;

    if( Math.abs(w) > precision )
    {
      //   .
      double  R = Math.abs(v/w) ;
      double  to_circle_center, from_circle_center ;

      to_circle_center = normalize_angle(
                           w*v >= 0 ?
                             heading + PI2 :
                             heading - PI2 ) ;
      from_circle_center = normalize_angle( to_circle_center + PI + w * T ) ;

      path = new vect_t( to_circle_center, R ) ;
      path.addrad( from_circle_center, R ) ;
    }
    else
    {
      //   .
      path = new vect_t( heading, v * T ) ;
    }

    return path ;
  }

  //     .
  private double
  get_bullet_speed( double firepower )
  {
    return ( 20 - 3*firepower ) ;
  }

  //    
  //    .
  private double
  get_turning_speed( double speed )
  {
    return Math.min
    (
      turning_speed_max,
      turning_speed_max * (0.4 + 0.6 * (1 - speed / speed_max))
    ) ;
  }

  //      0  2PI.
  private double
  normalize_angle( double a )
  {
    a = dPI + (a % dPI) ;
    a %= dPI ;
    return a ;
  }

  //    
  //       .
  private double
  get_angle_diff( double from, double to )
  {
    double  diff = to - from ;

    if( Math.abs(diff) <= PI ) return diff ;

    if( diff < 0 )
      diff += dPI ;
    else
    if( diff > 0 )
      diff -= dPI ;

    return diff % dPI ;
  }

  //      180,
  //    .
  private double
  shortest_turn( double da )
  {
    if( da > PI )
      da -= dPI ;
    else
    if( da < -PI )
      da += dPI ;

    return da ;
  }

  //    .
  private double
  get_angle( double x, double y )
  {
    double a ;

    if( y == 0 )
    {
      return x > 0 ? PI2 : 3*PI2 ;
    }

    a = Math.atan( x/y ) ;

    if( y < 0 ) a += PI ;

    return a ;
  }

  private void
  log( String str )
  {
    if( TO_CONSOLE )
      out.println( str ) ;
    if( TO_LOG_FILE )
      System.out.println( str ) ;
  }

  private void
  log( String str, String symbol )
  {
    String  out_str = symbol + " " + str ;
    if( TO_CONSOLE )
      out.println( out_str ) ;
    if( TO_LOG_FILE )
      System.out.println( out_str ) ;
  }

  private void
  log_begin( String a_name, int state, int event )
  {
    log( a_name +  ":  " + a_name
         + "    " + state
         + "   e" + event, "{" ) ;
  }

  private void
  log_end( String a_name, int state )
  {
    log( a_name +  ":  " + a_name
         + "      " + state, "}" ) ;
  }

  private void
  log_error( String a_name, int state )
  {
    log( a_name + ":   " + state + "!", "!" ) ;
  }

  private void
  log_trans( String a_name, int state_to, int state_from )
  {
    log( a_name +  ":  " + a_name
         + "    " + state_from
         + "   " + state_to, " T" ) ;
  }

  private void
  log_input( String x_name, String comment, boolean result )
  {
    String res_str = result ? "" : "" ;
    log( x_name + ": " + comment + "? - " + res_str + ".", " i" ) ;
  }

  private void
  log_output( String z_name, String comment )
  {
    log( z_name + ": " + comment + ".", " *" ) ;
  }

  //======
  //  "".
  //
  public class gunner_t extends Object
  {
    //*** .
    private final boolean SWITCH_DEBUG =      true ;
    private final boolean INPUTS_LOGGING =    true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean OUTPUTS_LOGGING =   true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A1_LOGGING =        true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A1_BEGIN_LOGGING =  true && A1_LOGGING && ANY_DEBUG ;
    private final boolean A1_END_LOGGING =    true && A1_LOGGING && ANY_DEBUG ;
    private final boolean A1_ERROR_LOGGING =  true && A1_LOGGING && ANY_DEBUG ;
    private final boolean A1_TRANS_LOGGING =  true && A1_LOGGING && ANY_DEBUG ;
    private final boolean A2_LOGGING =        true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A2_BEGIN_LOGGING =  true && A2_LOGGING && ANY_DEBUG ;
    private final boolean A2_END_LOGGING =    true && A2_LOGGING && ANY_DEBUG ;
    private final boolean A2_ERROR_LOGGING =  true && A2_LOGGING && ANY_DEBUG ;
    private final boolean A2_TRANS_LOGGING =  true && A2_LOGGING && ANY_DEBUG ;

    private double        old_heading, cur_heading ;  //  .
    private double        old_gun_heat, cur_gun_heat, //  .
                          gun_heat_decrement ;        //   .
    private target_t      cur_target ;                //  .
    private vect_t        cur_aim ;                   //  .
    private double        cur_firepower ;             //   .

    private double        da ;                        //        .
    private double        firepower ;                 //   .

    private int           y1 = 0 ;
    private int           y2 = 0 ;

    // .
    gunner_t()
    {
      gun_heat_decrement = 0 ;
      cur_aim = new vect_t() ;
    }

    //  .
    public void
    begin_round()
    {
      old_heading = cur_heading = getGunHeadingRadians() ;
      old_gun_heat = cur_gun_heat = getGunHeat() ;
      cur_target = null ;
      cur_aim.reset() ;
      last_fire_time = 0 ;
    }

    //  .
    public void
    begin_turn()
    {
      old_heading = cur_heading ;
      cur_heading = getGunHeadingRadians() ;
      old_gun_heat = cur_gun_heat ;
      cur_gun_heat = getGunHeat() ;

      da = 0 ;
      firepower = 0 ;

      A1(10) ;
      A2(10) ;
    }

    //  .
    public void
    end_turn()
    {
      setTurnGunRightRadians( da ) ;

      //log( "firepower = " + firepower ) ;
      if( firepower >= 0.1 )
      {
        //log( " firepower = " + firepower ) ;
        //log( "  gun = " + getGunHeadingRadians()*180/PI ) ;
        Bullet bullet = fireBullet( firepower ) ;
        if( bullet != null )
        {
          last_fire_time = cur_time ;
          if( cur_target != null )
            cur_target.shoot( firepower ) ;
        }
        //log( "  gun = " + getGunHeadingRadians()*180/PI ) ;
      }
      else
      {
        scan() ;
      }
    }

    //   .
    public double
    cur_heading()
    { return cur_heading ; }

    //   1.
    private void
    A1( int e )
    {
      int   y_old = y1 ;

      if( OBJECTS_LOGGING )
        log( "  '':" ) ;

      if( A1_BEGIN_LOGGING )
        log_begin( "A1", y1, e ) ;

      switch( y1 )
      {
        case 0:
          if( (y2 == 1) && x25() )                          y1 = 3 ;
          else
          { z30() ; z70() ; z50_1() ; }
        break ;

        case 1:
          if( x26() )          { z80() ;                    y1 = 0 ; }
          else
          if( x30() && x22() )                              y1 = 2 ;
          else
          { z40() ; z50_0() ; }
        break ;

        case 2:
          if( x26() )          { z80() ;                    y1 = 0 ; }
          else
          if( x21() && x50() ) { z60() ;                    y1 = 0 ; }
          else
          if( !x30() )                                      y1 = 1 ;
          else
          { z40() ; z50_0() ; }
        break ;

        case 3:
          if( x26() )          { z80() ;                    y1 = 0 ; }
          else
          if( x20() )                                       y1 = 1 ;
          else
          { z50_1() ; }
        break ;

        default :
          if( A1_ERROR_LOGGING )
            log_error( "A1", y1 ) ;
      }

      if( y1 != y_old )
      {

      if( A1_TRANS_LOGGING )
        log_trans( "A1", y1, y_old ) ;

      switch( y1 )
      {
        case 0:
          z30() ; z70() ;
        break ;

        case 1:
          z40() ; z50_0() ;
        break ;

        case 2:
          z40() ; z50_0() ;
        break ;

        case 3:
          z50_1() ;
        break ;
      }

      }

      if( A1_END_LOGGING )
        log_end( "A1", y1 ) ;
    }

    //   2.
    private void
    A2( int e )
    {
      int   y_old = y2 ;

      if( A2_BEGIN_LOGGING )
        log_begin( "A2", y2, e ) ;

      switch( y2 )
      {
        case 0:
          if( x10() )  { z36() ;     y2 = 1 ; }
          else
          { z35() ; }
        break ;

        case 1:
        break ;

        default :
          if( A2_ERROR_LOGGING )
            log_error( "A2", y2 ) ;
      }

      if( y2 != y_old )
      {

      if( A2_TRANS_LOGGING )
        log_trans( "A2", y2, y_old ) ;
      }

      if( A2_END_LOGGING )
        log_end( "A2", y2 ) ;
    }


    //***   .
    private boolean
    x10()
    {
      boolean result = (cur_time > 3) && (gun_heat_decrement > 0) ;

      if( INPUTS_LOGGING )
        log_input( "x10", "    ", result ) ;
      return result ;
    }

    private boolean
    x20()
    {
      boolean result = cur_gun_heat/gun_heat_decrement <= 3 ;

      if( INPUTS_LOGGING )
        log_input( "x20", "  ", result ) ;
      return result ;
    }

    private boolean
    x21()
    {
      boolean result = cur_gun_heat <= 0 ;

      if( INPUTS_LOGGING )
        log_input( "x21", " ", result ) ;
      return result ;
    }

    private boolean
    x22()
    {
      boolean result = cur_gun_heat/gun_heat_decrement <= 1 ;

      if( INPUTS_LOGGING )
        log_input( "x22", "      ", result ) ;
      return result ;
    }

    private boolean
    x25()
    {
      boolean result = cur_target != null ;

      if( INPUTS_LOGGING )
        log_input( "x25", " ", result ) ;
      return result ;
    }

    private boolean
    x26()
    {
      boolean result = true ;

      if( cur_target != null )
        result = !cur_target.is_tracked() ;

      if( INPUTS_LOGGING )
        log_input( "x26", " ", result ) ;
      return result ;
    }

    private boolean
    x30()
    {
      boolean result = true ;

      double  gun_to_go = get_angle_diff( cur_heading, cur_aim.a ) ;
      double  turn_direction = gun_to_go >= 0 ? 1 : -1 ;
                                  //     "".
      double  gun_turning_speed = turn_direction * gun_rotation_speed
                                 + driver.turning_speed() ;

      result = Math.abs( gun_to_go / gun_turning_speed ) <= 1 ;

      if( INPUTS_LOGGING )
        log_input( "x30", "      ", result ) ;
      return result ;
    }

    private boolean
    x50()
    {
      boolean result = true ;

      double  gun_to_go = get_angle_diff( cur_heading, cur_aim.a ) ; //shortest_turn( cur_aim.a - cur_heading ) ;
      result = Math.abs(gun_to_go) < precision ;

      if( INPUTS_LOGGING )
        log_input( "x50", " ", result ) ;
      return result ;
    }

    //***   .
    private void
    z30()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z30", " " ) ;

      cur_target = targets.get_closest_target( 8 ) ;
      if( cur_target == null )
        cur_target = targets.closest_target ;
    }

    private void
    z35()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z35", "   " ) ;

      gun_heat_decrement = old_gun_heat - cur_gun_heat ;
    }

    private void
    z36()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z36", "   " ) ;

      log( "gun_heat_decrement = " + gun_heat_decrement ) ;
    }

    private void
    z40()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z40", "  " ) ;

      double  P = 0.25 ;

      if( cur_life >= life_ok )
      {
        P = 0.2 ;
        if( cur_robots_count > 2 )
        {
          P = 0.4 ;
        }
      }
      else
      if( cur_life <= life_warning )
      {
        P = 0.25 ;
        if( cur_robots_count > 2 )
        {
          P = 0.5 ;
        }
      }
      else
      if( cur_life <= life_critical )
      {
        P = 0.6 ;
      }

      cur_firepower = cur_target.get_firepower(P) ;
    }

    private void
    z50_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z50_0", "     " ) ;

      if( cur_target != null  )
      {
        vect_t predicted_pos ;

        predicted_pos = cur_target.predict_position_medium(
                          get_bullet_speed(cur_firepower), 2 ) ;

        cur_aim.reset( predicted_pos.a, predicted_pos.R ) ;
        da = get_angle_diff( cur_heading, predicted_pos.a ) ;
      }
    }

    private void
    z50_1()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z50_1", "     " ) ;

      if( cur_target != null  )
      {
        vect_t predicted_pos ;

        predicted_pos = cur_target.predict_position_roughly(
                          get_bullet_speed(base_firepower), 2 ) ;

        cur_aim.reset( predicted_pos.a, predicted_pos.R ) ;
        da = get_angle_diff( cur_heading, predicted_pos.a ) ;
      }
    }

    private void
    z60()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z60", "" ) ;

      firepower = cur_firepower ;

      //log( "  gun = " + getGunHeadingRadians()*180/PI ) ;
    }

    private void
    z70()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z70", "   " ) ;

      if( cur_target != null )
        cur_target.reset_speed_history() ;
    }

    private void
    z80()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z80", "  " ) ;

      cur_target = null ;
    }
  } // gunner_t

  //======
  //  "".
  //
  public class driver_t extends Object
  {
    //*** .
    private final boolean SWITCH_DEBUG =      true ;
    private final boolean INPUTS_LOGGING =    true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean OUTPUTS_LOGGING =   true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A3_LOGGING =        true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A3_BEGIN_LOGGING =  true && A3_LOGGING && ANY_DEBUG ;
    private final boolean A3_END_LOGGING =    true && A3_LOGGING && ANY_DEBUG ;
    private final boolean A3_ERROR_LOGGING =  true && A3_LOGGING && ANY_DEBUG ;
    private final boolean A3_TRANS_LOGGING =  true && A3_LOGGING && ANY_DEBUG ;

    private final double  walls_k = 100 ;        //  ""  .
    private final double  heading_delta = Math.toRadians(30) ;

    private long          T110 ;                 //    T110.

    private double        old_heading, cur_heading ;   //  .
    private double        old_x, old_y, cur_x, cur_y ; // .
    private double        turning_speed ;              //   .
    private double        old_speed, cur_speed ;       //  .

    private double        da ;                         //       .
    private double        speed ;                      //        .
    private vect_t        direction = new vect_t() ;   //  .

    private int           y3 = 0 ;

    //  .
    public void
    begin_round()
    {
      old_heading = cur_heading = getHeadingRadians() ;
      old_speed = cur_speed = 0 ;
      old_x = cur_x = getX() ;
      old_y = cur_y = getY() ;
      turning_speed = 0 ;
      T110 = 0 ;
      direction.reset() ;

      da = 0 ;
      speed = speed_max ;
    }

    //  .
    public void
    begin_turn()
    {
      old_heading = cur_heading ;
      cur_heading = getHeadingRadians() ;
      old_x = cur_x ; cur_x = getX() ;
      old_y = cur_y ; cur_y = getY() ;
      old_speed = cur_speed ;
      cur_speed = Math.sqrt( Math.pow( cur_x-old_x, 2 ) + Math.pow( cur_y-old_y, 2 )) ;
      cur_speed = cur_speed * ( speed >= 0 ? 1 : -1 ) ;
      turning_speed = get_angle_diff( old_heading, cur_heading ) ;

      da = 0 ;

      A3(10) ;
    }

    //   .
    public void
    robot_collision()
    {
      A3(40) ;
    }

    //   .
    public void
    wall_collision()
    {
      A3(41) ;
    }

    //   .
    public void
    hit_by_bullet()
    {
      A3(45) ;
    }

    //  .
    public void
    end_turn()
    {
      setTurnRightRadians( da ) ;
      setAhead( speed*100 ) ;
    }

    //   .
    public double
    turning_speed()
    { return turning_speed ; }

    //   3.
    private void
    A3( int e )
    {
      int   y_old = y3 ;

      if( OBJECTS_LOGGING )
        log( "  '':" ) ;

      if( A3_BEGIN_LOGGING )
        log_begin( "A3", y3, e ) ;

      switch( y3 )
      {
        case 0:
          if( !x100() && !x105() )                                y3 = 1 ;
          else
          if( x110() )
          { z200_0() ; z200_1() ; z200_2() ; }
          else
          { z200_1() ; z200_2() ; }
        break ;

        case 1:
          if( e == 45 )                                           y3 = 2 ;
          else
          if( x100() || x105() || e == 40 || e == 41 )            y3 = 0 ;
          else
          if( x110() )                                            y3 = 3 ;
          else
          { z210_1() ; z210_2() ; }
        break ;

        case 2:
          if( x105() || x110() || e == 40 || e == 41 )            y3 = 0 ;
          else
          { z220_1() ; z220_2() ; }
        break ;

        case 3:
          if( e == 45 )                                           y3 = 2 ;
          else
          if( x110() )                                            y3 = 0 ;
          else
          { z200_2() ; }
        break ;

        default :
          if( A3_ERROR_LOGGING )
            log_error( "A3", y3 ) ;
      }

      if( y3 != y_old )
      {

      if( A3_TRANS_LOGGING )
        log_trans( "A3", y3, y_old ) ;

      switch( y3 )
      {
        case 0:
          z200_0() ; z200_1() ; z200_2() ;
        break ;

        case 1:
          z210_0() ; z210_1() ; z210_2() ;
        break ;

        case 2:
          z220_0() ; z220_1() ; z220_2() ;
        break ;

        case 3:
          z230_0() ; z200_2() ;
        break ;
      }

      }

      if( A3_END_LOGGING )
        log_end( "A3", y3 ) ;
    }

    //***   .
    private boolean
    x100()
    {
      boolean   result = true ;

      if( targets.closest_target != null )
        result = targets.closest_target.R < 300 ;

      if( INPUTS_LOGGING )
        log_input( "x100", " ", result ) ;
      return result ;
    }

    private boolean
    x105()
    {
      double    collision_delta = robot_size2 + 40 ;

      boolean   result =
           cur_x < 0 + collision_delta
        || cur_x > battlefield_width - collision_delta
        || cur_y < 0 + collision_delta
        || cur_y > battlefield_height - collision_delta ;

      if( INPUTS_LOGGING )
        log_input( "x105", " ", result ) ;
      return result ;
    }

    private boolean
    x110()
    {
      boolean   result = cur_time >= T110 ;

      if( INPUTS_LOGGING )
        log_input( "x110", "  T110", result ) ;
      return result ;
    }

    //***   .
    private void
    z200_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z200_0", "    ''" ) ;

      setMaxVelocity(10) ;
      get_direction() ;
    }

    private void
    z200_1()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z200_1", "     ''" ) ;

      //   .
      direction.reset( direction.a, 1 ) ;

      double angle_diff = normalize_angle( direction.a +
                                           (random.nextBoolean() ? PI2 : -PI2) ) ;
      direction.addrad( angle_diff, 0.4 ) ;
    }

    private void
    z200_2()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z200_2", "     ''" ) ;

      calculate_movement_order( true ) ;
    }

    private void
    z210_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z210_0", "    ''" ) ;

      double TTT = targets.closest_target != null
                   ? targets.closest_target.R / 20.0 : 10 ;

      TTT = TTT * ( random.nextDouble() * 0.5 + 0.8 ) ;
      T110 = cur_time + Math.round(TTT) ;

      get_direction() ;
      setMaxVelocity(10) ;

      if( targets.closest_target != null )
      {
        double delta1 =
          Math.abs(get_angle_diff( direction.a, targets.closest_target.a )) ;
        double delta2 =
          Math.abs(get_angle_diff( direction.a,
                                   normalize_angle(targets.closest_target.a + PI) )) ;
        if( delta1 > heading_delta || delta2 > heading_delta )
        {
          direction.a = normalize_angle( targets.closest_target.a + PI
                                         + (random.nextBoolean() ? PI2/2 : -PI2/2) ) ;
        }
      }
    }

    private void
    z210_1()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z210_1", "     ''" ) ;
    }

    private void
    z210_2()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z210_2", "     ''" ) ;

      calculate_movement_order( false ) ;
      da = 0 ;
      //da = movement_direction ;
    }

    private void
    z220_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z220_0", "    ''" ) ;

      T110 = cur_time + 17 ;
      get_direction() ;
      direction.a = - PI2 * (direction.a/Math.abs(direction.a)) ;
      setMaxVelocity(5) ;
    }

    private void
    z220_1()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z220_1", "     ''" ) ;
    }

    private void
    z220_2()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z220_2", "   ''" ) ;

      calculate_movement_order( false ) ;
    }

    private void
    z230_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z230_0", "    ''" ) ;

      double TTT = targets.closest_target != null
                   ? targets.closest_target.R / 20.0 : 10 ;

      TTT = TTT * ( random.nextDouble() * 0.3 + 0.3 ) ;

      T110 = cur_time + Math.round(TTT) ;
      setMaxVelocity( 0 ) ;
    }

    //***  .
    //         .
    private void
    get_direction()
    {
      direction.reset() ;

      //    .
      direction.adddec( walls_k / cur_x, 0 ) ;
      direction.adddec( -walls_k / (battlefield_width - cur_x), 0 ) ;
      direction.adddec( 0, walls_k / cur_y ) ;
      direction.adddec( 0, -walls_k / (battlefield_height - cur_y) ) ;

      //      .
                     //     " ".
      direction.add( targets.get_reaction_vector() ) ;
    }

    //    .
    private void
    calculate_movement_order( boolean reverse_alloud )
    {
      double  da1,  // ,       .
              da2 ; // ,       .

      da1 = get_angle_diff( cur_heading, direction.a ) ;
      da2 = get_angle_diff( cur_heading, normalize_angle( direction.a - PI )) ;

      if( reverse_alloud )
      {
        if( Math.abs(da1) < Math.abs(da2) )
        {
          da = da1 ;
          speed = speed_max ;
        }
        else
        {
          da = da2 ;
          speed = -speed_max ;
        }
      }
      else
      {
        if( speed > 0 )
          da = da1 ;
        else
          da = da2 ;
      }
    }
  } // driver_t

  //======
  //  "".
  //
  public class radar_t extends Object
  {
    //*** .
    private final boolean SWITCH_DEBUG =      true ;
    private final boolean INPUTS_LOGGING =    true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean OUTPUTS_LOGGING =   true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A4_LOGGING =        true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A4_BEGIN_LOGGING =  true && A4_LOGGING && ANY_DEBUG ;
    private final boolean A4_END_LOGGING =    true && A4_LOGGING && ANY_DEBUG ;
    private final boolean A4_ERROR_LOGGING =  true && A4_LOGGING && ANY_DEBUG ;
    private final boolean A4_TRANS_LOGGING =  true && A4_LOGGING && ANY_DEBUG ;

    private double        old_heading, cur_heading ; //  .
    private double        da ;                       // ,        .
    private double        radar_path ;               //   .

    private int           y4 = 0 ;

    //  .
    public void
    begin_round()
    {
      old_heading = cur_heading = getRadarHeadingRadians() ;
      da = 0 ;
      radar_path = 0 ;
    }

    //  .
    public void
    begin_turn()
    {
      old_heading = cur_heading ;
      cur_heading = getRadarHeadingRadians() ;
      radar_path = radar_path + get_angle_diff( old_heading, cur_heading ) ;

      A4(10) ;
    }

    //  .
    public void
    end_turn()
    {
      setTurnRadarRightRadians( da ) ;
    }

    //   4.
    private void
    A4( int e )
    {
      int   y_old = y4 ;

      if( OBJECTS_LOGGING )
        log( "  '':" ) ;

      if( A4_BEGIN_LOGGING )
        log_begin( "A4", y4, e ) ;

      switch( y4 )
      {
        case 0:
        {
          boolean   X70 = x70() ;

          if( X70 && x80() ) { z101_0() ;                    y4 = 1 ; }
          else
          if( X70 )                                          y4 = 2 ;
          else
          { z100_0() ; }
        }
        break ;

        case 1:
        {
          boolean   X70 = x70() ;

          if( X70 && x80() ) { z101_0() ;                    y4 = 0 ; }
          else
          if( X70 )                                          y4 = 3 ;
          else
          { z100_1() ; }
        }
        break ;

        case 2:
          if( x70() ) { z101_0() ;                           y4 = 0 ; }
          else
                                                             y4 = 0 ;
        break ;

        case 3:
          if( x70() ) { z101_0() ;                           y4 = 1 ; }
          else
                                                             y4 = 1 ;
        break ;


        default :
          if( A4_ERROR_LOGGING )
            log_error( "A4", y4 ) ;
      }

      if( y4 != y_old )
      {

      if( A4_TRANS_LOGGING )
        log_trans( "A4", y4, y_old ) ;

      switch( y4 )
      {
        case 0:
          z100_0() ;
        break ;

        case 1:
          z100_1() ;
        break ;

        case 2:
          z101_0() ; z100_1() ;
        break ;

        case 3:
          z101_0() ; z100_0() ;
        break ;
      }

      }

      if( A4_END_LOGGING )
        log_end( "A4", y4 ) ;
    }

    //***   .
    private boolean
    x70()
    {
                       //     " ".
      boolean result = targets.scan_completed() ;

      if( INPUTS_LOGGING )
        log_input( "x70", "  ", result ) ;
      return result ;
    }

    private boolean
    x80()
    {
      boolean result = Math.abs(radar_path) < PI ;

      if( INPUTS_LOGGING )
        log_input( "x80", "    180 ", result ) ;
      return result ;
    }

    //***   .
    private void
    z100_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z100_0", "  " ) ;

      da = -1000 ;
    }

    private void
    z100_1()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z100_1", "  " ) ;

      da = 1000 ;
    }

    private void
    z101_0()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z101_0", "    " ) ;

      radar_path = 0 ;
    }
  } // radar_t

  //======
  //  "C ".
  //
  public class targets_t extends Object
  {
    //*** .
    public target_t       closest_target ;       //  .
    private final double  targets_k_delta = 13 ; //  
                                                 // ""   
                                                 //    .

    private double        targets_k ;            //  ""  .
    private Hashtable     targets_table = new Hashtable(1) ;
    private long          last_scan_completion_time = 0 ;

    //  .
    public void
    begin_round()
    {
      Enumeration targets_list = targets_table.elements() ;
      target_t    t ;

      //  ""      .
      targets_k = 270 - getOthers() * targets_k_delta ;
      if( targets_k <= 0 ) targets_k = 10 ;
      closest_target = null ;

      while( targets_list.hasMoreElements() )
      {
        t = (target_t)targets_list.nextElement() ;
        t.begin_round() ;
        //log( t.name ) ;
      }

      last_scan_completion_time = 0 ;
    }

    //  .
    public void
    begin_turn()
    {
      Enumeration targets_list = targets_table.elements() ;
      target_t    t ;

      while( targets_list.hasMoreElements() )
      {
        t = (target_t)targets_list.nextElement() ;
        t.refresh() ;
      }

      closest_target = get_closest_target( 100 ) ;
    }

    //  .
    public void
    update( ScannedRobotEvent e )
    {
      target_t    t ;
      String      robot_name = e.getName() ;

      t = (target_t)targets_table.get( robot_name ) ;
      if( t != null )
      {
        //  .  .

        //log( getTime() + ":    " + robot_name ) ;
        t.update(e) ;
      }
      else
      {
        //      .
        //log( "  (" + robot_name + ")" ) ;
        t = new target_t(e) ;
        targets_table.put( robot_name, t ) ;
      }
    }

    //  .
    public void
    one_less( RobotDeathEvent e )
    {
      target_t    t ;
      String      robot_name = e.getName() ;

      t = (target_t)targets_table.get( robot_name ) ;
      targets_k += targets_k_delta ;
      if( t != null )
        t.destroyed() ;
    }

    //   .
    public void
    hit( BulletHitEvent e )
    {
      target_t    t ;
      String      robot_name = e.getName() ;

      //log( "Targets hit for " + robot_name ) ;

      t = (target_t)targets_table.get( robot_name ) ;
      if( t != null )
        t.hit() ;
    }

    //   .
    public void
    collide( HitRobotEvent e )
    {
      target_t    t ;
      String      robot_name = e.getName() ;

      //log( "Targets hit for " + robot_name ) ;

      t = (target_t)targets_table.get( robot_name ) ;
      if( t != null )
        t.collide() ;
    }

    //   .
    public void
    hit_by_bullet( HitByBulletEvent e )
    {
      target_t    t ;
      String      robot_name = e.getName() ;

      t = (target_t)targets_table.get( robot_name ) ;
      if( t != null )
        t.hit_by_bullet() ;
    }

    //   .
    public target_t
    get_closest_target( double time_on_aiming )
    {
      Enumeration targets_list = targets_table.elements() ;
      target_t    chosen_target = null, t = null ;

      //  ,      ,
      //    ,  .
      while( targets_list.hasMoreElements() )
      {
        t = (target_t)targets_list.nextElement() ;
        if( t.is_tracked() )
        {
          //log( " " + t.name + "  " + t.a *180/PI ) ;
          //if( Math.abs(shortest_turn( t.a - gunner.cur_heading() ))
          if( Math.abs(get_angle_diff( gunner.cur_heading(), t.a ))
              < time_on_aiming * gun_rotation_speed )
          {
            //     .
            //log( t.name + "  ." ) ;

            if( chosen_target == null )
              chosen_target = t ;
            else
            if( t.R < chosen_target.R )
              chosen_target = t ;
          }
        }
      }

      return chosen_target ;
    }

    //       .
    public vect_t
    get_reaction_vector()
    {
      Enumeration targets_list = targets_table.elements() ;
      target_t    t ;
      vect_t      reaction = new vect_t() ;

      while( targets_list.hasMoreElements() )
      {
        t = (target_t)targets_list.nextElement() ;
        if( t.is_tracked() )
        {
          reaction.addrad( normalize_angle(t.a+PI), targets_k / t.R ) ;
        }
      }

      return reaction ;
    }

    // ,     .
    public boolean
    scan_completed()
    {
      Enumeration targets_list = targets_table.elements() ;
      target_t    t ;
      int         tracked_targets = 0 ;

      //log( " scan_completed" ) ;

      if( !targets_list.hasMoreElements() ) return false ;
      if( cur_time < 20 ) return false ;

      // ,     .
      while( targets_list.hasMoreElements() )
      {
        t = (target_t)targets_list.nextElement() ;
        if( t.is_tracked() )
        {
          //  .

          if( !t.was_scanned_after(last_scan_completion_time) )
          {
            //       .
            //       .
            return false ;
          }
          tracked_targets++ ;
        }
      }

      //  , :
      //  -    ;
      //  -   ;
      //  -    (  ) .
      //     ,    .

      if( tracked_targets > 0 )
      {
        last_scan_completion_time = cur_time ;
        return true ;
      }
      else
        return false ;
    }

    //======
    //
    //
    public void
    show_statistics()
    {
      Enumeration targets_list = targets_table.elements() ;
      target_t    t ;

      while( targets_list.hasMoreElements() )
      {
        t = (target_t)targets_list.nextElement() ;
        t.show_statistics() ;
      }
    }
  } // targets_t

  //======
  //  "".
  //
  public class target_t extends Object
  {
    //*** .
    private final boolean SWITCH_DEBUG =      true ;
    private final boolean INPUTS_LOGGING =    true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean OUTPUTS_LOGGING =   true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A5_LOGGING =       true && SWITCH_DEBUG && ANY_DEBUG ;
    private final boolean A5_BEGIN_LOGGING = true && A5_LOGGING && ANY_DEBUG ;
    private final boolean A5_END_LOGGING =   true && A5_LOGGING && ANY_DEBUG ;
    private final boolean A5_ERROR_LOGGING = true && A5_LOGGING && ANY_DEBUG ;
    private final boolean A5_TRANS_LOGGING = true && A5_LOGGING && ANY_DEBUG ;
    private final double  long_range = 650 ;
    private final double  close_range = 150 ;
    private final double  point_blank_range = 70 ;
    private final long    old_info = 20 ; //  ,  
                                          //   .
    private String       name ;           //  .
    private double       a,               // .
                         R,               // .
                         v, old_v,        //  .
                         med_v,
                         dv,              //  .
                         w, old_w,        //  .
                         med_w ;
    private boolean      collision_detected ;

    private double       cur_target_heading,   //      .
                         old_target_heading ;  //      .

    private long         last_update_time ; //     .
    private double       prediction_interval ;  //     .
    private vect_t       predicted_vector = new vect_t() ; //     
                                                           //  .
    private double       cur_target_life ;
    private double       hits, shots ;
    private double       T_base, P_base, P0 ;
    private double       T_medium ;

    private int          y5 = 0 ;

    // .
    target_t( ScannedRobotEvent e )
    {
      name = e.getName() ;
      a = normalize_angle( Cynical_3.this.getHeadingRadians()
                         + e.getBearingRadians()) ;
      R = e.getDistance() ;
      med_v = old_v = v = e.getVelocity() ;
      dv = 0 ;
      med_w = old_w = w = 0 ;
      old_target_heading = cur_target_heading = e.getHeadingRadians() ;
      last_update_time = cur_time ;

      hits = 0 ; shots = 0 ;
      T_medium = T_base = 3 ;
      P_base = 1 ; P0 = 1.2 ;

      A5(100,e) ;
    }

    //  .
    public void
    begin_round()
    {
      A5(120, null) ;
    }

    //   .
    public void
    refresh()
    {
      A5(140, null) ;
    }

    //  .
    public void
    update( ScannedRobotEvent e )
    {
      //log( "Updating target " + name ) ;

      A5(100, e) ;
    }

    //  .
    public void
    destroyed()
    {
      A5(110, null) ;
    }

    //   .
    public void
    hit()
    {
      A5(130, null) ;
    }

    //   .
    public void
    collide()
    {
      A5(135, null) ;
    }

    //   .
    public void
    hit_by_bullet()
    {
      A5(136, null) ;
    }

    //   .
    public void
    shoot( double firepower )
    {
      double T = predicted_vector.R / get_bullet_speed(firepower) ;

      T = T < 1 ? 1 : T ;

      double P = P0 - T * ( P0 - P_base ) / T_base  ;

      P = P > P0 ? P0 : P ;
      P = P < 0 ? 0 : P ;

      //log( ", P = " + P + ", F = " + firepower ) ;

      P = P / 1.2 ;

      P_base = P0 - T_base * ( P0 - P ) / T ;
      P_base = P_base > P0 ? P0 : P_base ;
      P_base = P_base < 0 ? 0 : P_base ;

      T_medium = ( T_medium + T ) / 2 ;

      //log( ", P = " + P + ", Pb = " + P_base + ", Tm = " + T_medium ) ;

      shots++ ;
    }

    //   .
    public void
    reset_speed_history()
    {
      med_w = w ;
      med_v = v ;
    }

    //  .
    public boolean
    is_tracked()
    {
      return y5 == 2 ;
    }

    //   .
    public boolean
    is_unknown()
    {
      return y5 == 0 ;
    }

    //       .
    public boolean
    was_scanned_after( long scan_time )
    {
      return last_update_time > scan_time ;
    }

    //       .
    public double
    get_firepower( double P )
    {
      double  R = predicted_vector.R ;
      double  S = ( P0 - P_base ) * R / ( ( P0 - P )*T_base ) ;
      double  F = ( 20 - S ) / 3.0 ;

      //log( "F = " + F ) ;

      F = F > max_firepower ? max_firepower : F ;
      double  damage = F * 3
                       + ( F > 1 ? 2 * (F-1) : 0 ) ;

      if( damage > cur_target_life )
      {
        if( cur_target_life < 3 )
        {
          F = cur_target_life / 3.0 ;
          F = F < 0.1 ? 0.1 : F ;
        }
        else
        {
          F = (cur_target_life + 2.0) / 5.0 ;
        }
      }

      if( F < 0.1 )
      {
        if( (R < long_range) && (cur_life > life_warning) )
        {
          F = 0.1 ;
        }
        else
        if(     ( cur_target_life > cur_life )
            && ( (cur_time - last_fire_time) > fire_delay_critical ))
        {
          F = 0.1 ;
        }
      }
      else
      {
        if( cur_life < life_critical )
        {
          F = F > cur_life / 5 ? cur_life / 5 : F ;
          F = F < 0.1 ? 0.1 : F ;

          if( cur_life < 0.2 )
            F = 0 ;
        }
      }

      //log( "get_firepower: F = " + F + ", R = " + R + ", Pb = " + P_base + ", P0 = " + P0 + ", Tb = " + T_base + ", P = " + P ) ;

      return F ;
    }

    //   .
    public vect_t
    predict_position_roughly( double bullet_speed, double prediction_gap )
    {
      double      cur_bullet_time ;

      cur_bullet_time = prediction_gap + R / bullet_speed ;

      predicted_vector.reset( a, R ) ;

      if( R > close_range )
      {
        if( Math.abs(v) > precision )
        {
          predicted_vector.add( get_path( med_v, med_w,
                                          cur_target_heading, cur_bullet_time )) ;
        }
      }

      return predicted_vector ;
    }

    //   .
    public vect_t
    predict_position_exactly( double bullet_speed, double prediction_gap )
    {
      predict_position( v, w, bullet_speed, prediction_gap ) ;

      return predicted_vector ;
    }

    //   .
    public vect_t
    predict_position_medium( double bullet_speed, double prediction_gap )
    {
      predict_position( med_v, med_w, bullet_speed, prediction_gap ) ;

      return predicted_vector ;
    }

    //  .
    public void
    show_statistics()
    {
      log( "----   " + name + " ----" ) ;
      log( ": " + shots + ", : " + hits ) ;
      log( ": " + hits/shots + ", : " + P_base ) ;
      log( "---------" ) ;
    }

    //   5.
    private void
    A5( int e, Event robocode_event )
    {
      int   y_old = y5 ;

      if( OBJECTS_LOGGING )
        log( "  '' (" + name + "):" ) ;

      if( A5_BEGIN_LOGGING )
        log_begin( "A5", y5, e ) ;

      switch( y5 )
      {
        case 0:
          if( e == 100 ) { z1001(robocode_event) ;   y5 = 2 ; }
          else
          if( e == 130 ) { z1010(robocode_event) ;   y5 = 2 ; }
          else
          if( e == 135 || e == 136 )                 y5 = 2 ;
          else
          if( e == 140 && x1000() )                  y5 = 1 ;
        break ;

        case 1:
          if( e == 100 ) { z1001(robocode_event) ;   y5 = 2 ; }
          else
          if( e == 130 ) { z1010(robocode_event) ;   y5 = 2 ; }
          else
          if( e == 135 || e == 136 )                 y5 = 2 ;
          else
          if( e == 120 )                             y5 = 0 ;
        break ;

        case 2:
          if( e == 110 || e == 140 && x1000() )      y5 = 1 ;
          else
          if( e == 120 )                             y5 = 0 ;
          else
          if( e == 100 )
          { z1001(robocode_event) ; }
          else
          if( e == 130 )
          { z1010(robocode_event) ; }
        break ;

        default :
          if( A5_ERROR_LOGGING )
            log_error( "A5", y5 ) ;
      }

      if( y5 != y_old )
      {

      if( A5_TRANS_LOGGING )
        log_trans( "A5", y5, y_old ) ;

      switch( y5 )
      {
        case 0:
          z1000() ;
        break ;

        case 1:
          z1000() ;
        break ;
      }

      }

      if( A5_END_LOGGING )
        log_end( "A5", y5 ) ;
    }

    //***   .
    private boolean
    x1000()
    {
      boolean result = (cur_time - last_update_time) > old_info ;

      if( INPUTS_LOGGING )
        log_input( "x1000", "   ", result ) ;
      return result ;
    }

    //***   .
    private void
    z1000()
    {
      if( OUTPUTS_LOGGING )
        log_output( "z1000", "  " ) ;

      med_w = old_w = w = 0 ;
      dv = 0 ;
      med_v = old_v = v = 0 ;
      last_update_time = 0 ;
      predicted_vector.reset() ;
    }

    private void
    z1001( Event event )
    {
      if( OUTPUTS_LOGGING )
        log_output( "z1001", "  " ) ;

      if( last_update_time != cur_time ) //   .
      {
        ScannedRobotEvent   e = (ScannedRobotEvent) event ;

        //log( "Updating target " + name ) ;

        cur_target_life = e.getLife() ;
        R = Math.abs(e.getDistance()) ;
        a = normalize_angle( getHeadingRadians() + e.getBearingRadians()) ;

        old_v = v ;
        v = e.getVelocity() ;
        med_v = (v + med_v) / 2.0 ;
        dv = (v - old_v)/( cur_time - last_update_time ) ;

        old_target_heading = cur_target_heading ;
        cur_target_heading = normalize_angle(e.getHeadingRadians()) ;
        old_w = w ;
        w = get_angle_diff(old_target_heading, cur_target_heading)
              /(cur_time - last_update_time) ;
        med_w = (w + med_w) / 2.0 ;

        //log( "v = " + v + ", dv = " + dv + ", w = " + w + ", accelerating = " + accelerating + ", braking = " + braking ) ;
        //log( "w = " + w ) ;

        last_update_time = cur_time ;

        //log( "Update (" + name + "): a = " + a*180/PI + ", R = " + R ) ;
      }
    }

    private void
    z1010( Event e )
    {
      if( OUTPUTS_LOGGING )
        log_output( "z1010", "    " ) ;

      double P = P0 - T_medium * ( P0 - P_base ) / T_base  ;

      P = P * 1.4 ;
      P = P > P0 ? P0 : P ;
      P = P < 0 ? 0 : P ;

      P_base = P0 - T_base * ( P0 - P ) / T_medium ;
      P_base = P_base > P0 ? P0 : P_base ;
      P_base = P_base < 0 ? 0 : P_base ;

      hits++ ;
    }

    //***  .

    //    :
    // -     ;
    // - ,       prediction_gap.
    private vect_t
    predict_position( double v, double w,
                      double bullet_speed, double prediction_gap )
    {
      final int   maximum_iterations = 5 ;
      double      old_bullet_time, cur_bullet_time ;
      int         i = 0 ;
      vect_t      cur_prediction = new vect_t() ;

      if( R < point_blank_range )
      {
        cur_prediction.reset( a, R ) ;
      }
      else
      if( Math.abs(v) > precision )
      {
        old_bullet_time = cur_bullet_time = prediction_gap + R / bullet_speed ;

        collision_detected = false ;
        cur_prediction = get_predicted_point( v, w, cur_bullet_time, true ) ;

        if( !collision_detected )
          for( i = 0 ; i < maximum_iterations ; i++ )
          {
            old_bullet_time = cur_bullet_time ;
            cur_bullet_time = prediction_gap + cur_prediction.R / bullet_speed ;
            if( Math.abs( cur_bullet_time - old_bullet_time ) < 0.5 ) break ;
            cur_prediction = get_predicted_point( v, w, cur_bullet_time, false ) ;
          }

        //log( " : " + i++ ) ;

      }
      else
      {
        cur_prediction.reset( a, R ) ;
      }

      predicted_vector.reset( cur_prediction.a, cur_prediction.R ) ;

      return predicted_vector ;
    }

    //      .
    private vect_t
    get_predicted_point( double v, double w,
                         double t, boolean check_collisions )
    {
      vect_t    cur_prediction = new vect_t( a, R ) ;
                //    ,    
                //     .
      double    time_discret = 5 ;

      if( check_collisions )
      {
        //  (  )   
        //    .
        //       
        //       .
        //      - 
        //       
        //       .
        for( double i = 0 ; i*time_discret < t ; i++ )
        {
          double  time_delta = Math.min( time_discret,
                                         t - i*time_discret ) ;

          cur_prediction.add( get_path( v, w, cur_target_heading, time_delta )) ;

          if( vector_out_of_field( cur_prediction ) )
          {
            //  .
            //  ,    ,
            //    [i*time_discret ; i*time_discret + time_delta].
            //    .

            collision_detected = true ;
            cur_prediction.reset( a, R ) ;
            cur_prediction.add( get_path( v, w, cur_target_heading, i*time_discret )) ;

            for( int j = 1 ; j <= time_delta ; j++ )
            {
              cur_prediction.add( get_path( v, w, cur_target_heading, 1 )) ;
              if( vector_out_of_field( cur_prediction ) )
              {
                //        .
                //   i*time_discret + j.
                //        .
                cur_prediction.reset( a, R ) ;
                cur_prediction.add(
                  get_path( v, w, cur_target_heading, i*time_discret + j )) ;
                return cur_prediction ;
              }
            }

            //   ,   -    
            //  ,    .
            cur_prediction.reset( a, R ) ;
            cur_prediction.add(
              get_path( v, w, cur_target_heading, i*time_discret + time_delta )) ;
            return cur_prediction ;
          }
        }  // for   .
      } // if( check_collisions )

      //   ,        .
      cur_prediction.reset( a, R ) ;
      cur_prediction.add(
        get_path( v, w, cur_target_heading, t )) ;

      return cur_prediction ;
    }

    // ,   ,  
    //      .
    private boolean
    vector_out_of_field( vect_t vector )
    {
      double  x, y ;
      x = getX() + vector.x ;
      y = getY() + vector.y ;

      return (  x < 0 + collision_delta
             || x > battlefield_width - collision_delta
             || y < 0 + collision_delta
             || y > battlefield_height - collision_delta ) ;
    }
  }   // target_t class.

  //======
  //  "".
  //
  public class vect_t extends Object
  {
    //*** .
    public double a, R, x, y ;

    //*** .
    vect_t()
    { reset() ; } ;

    vect_t( double a1, double R1 )
    { reset(a1,R1) ; }

    //  .
    public void reset()
    { a = 0 ; R = 0 ; x = 0 ; y = 0 ; }

    //  .
    public void reset( double a1, double R1 )
    { a = a1 ; R = R1 ; x = R1 * Math.sin(a1) ; y = R1 * Math.cos(a1) ; } ;

    //  .
    public void add( vect_t vect2 )
    {
      adddec( vect2.x, vect2.y ) ;
    }

    //  ,     .
    public void adddec( double x2, double y2 )
    {
      double a1 = a, R1 = R, x1 = x, y1 = y ;
      double x3 = 0, y3 = 0 ;
      double a3 = 0, R3 = 0 ;

      x3 = x1 + x2 ;
      y3 = y1 + y2 ;
      R3 = x3 * x3 + y3 * y3 ;
      x = x3 ; y = y3 ;
      if( R3 < 0 ) return ;
      R3 = Math.sqrt( R3 ) ;
      a3 = get_angle( x3, y3 ) ;
      a = normalize_angle(a3) ; R = R3 ;
    }

    //  ,     .
    public void addrad( double a2, double R2 )
    {
      double a1 = a, R1 = R, x1 = x, y1 = y ;
      double x2 = 0, y2 = 0 ;
      double x3 = 0, y3 = 0 ;
      double a3 = 0, R3 = 0 ;

      x2 = R2 * Math.sin(a2) ; y2 = R2 * Math.cos(a2) ;
      x3 = x1 + x2 ;
      y3 = y1 + y2 ;
      R3 = x3 * x3 + y3 * y3 ;
      x = x3 ; y = y3 ;

      if( R3 < 0 ) return ;
      R3 = Math.sqrt( R3 ) ;
      a3 = get_angle( x3, y3 ) ;

      //log( "x1 = " + x1 + ", y1 = " + y1 + ", a1 = " + a1*180/PI ) ;
      //log( "x2 = " + x2 + ", y2 = " + y2 + ", a2 = " + a2*180/PI ) ;
      //log( "x3 = " + x3 + ", y3 = " + y3 + ", a3 = " + a3*180/PI ) ;
      //log( "---" ) ;
      a = normalize_angle(a3) ; R = R3 ;

      //log( "(" + a1 + "," + R1 + ") + (" + a2 + "," + R2 + ") = (" + a3 + "," + R3 + ")" ) ;
    }
  }  // vect_t class.
} //  "".

